/***************************************************************************
*                                Core function library                     *
*                         Copyright 1994, Viewpoint engineering            *
*  These functions are handy little dudes for occasional use (I use them   *
*  All the time)                                                           *
*  NOT Warrantied!!!!! If it breaks YOU GET BOTH PARTS!!!!!                *
***************************************************************************/
#define _JPI_WIN_
#include <window.h>
#include <fcntl.h>
#include <string.h>
#include <dir.h>
#include <dos.h>
#include <stat.h>
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <ctype.h>
#include <tsxlib.h>

#include "cla.h"


#define  exist(f) !access((f),0)                    /* check if file exist */

#define TRIMRIGHT    1
#define TRIMLEFT     0
#define SHUFFLERIGHT 1
#define SHUFFLELEFT  0

void trimzeros(void *StrPtr, short TrimSide);
void shufflestring(char **SuffleStr, unsigned char Direction);
short FileExists(char *FileName);
void _FileDate(char *FileName, char *DateBuff);
void DeleteFiles(char *FileName);
short IsLocked(char *FileName);
void CClip(short Len, char *Str);
void StuffFile(char *FileName, char *LogString);

void trimzeros(void *StrPtr, short TrimSide) {

char   *TrimString;


        if (TrimSide) {
                TrimString = ((char *) StrPtr);
                TrimString += (strlen(TrimString) - 1);
        } else {
                TrimString = (char *) StrPtr;
        }
  for(; *TrimString == '0';) {
    switch (TrimSide) {
    case TRIMLEFT:
      shufflestring(&TrimString, SHUFFLELEFT);
      break;
    case TRIMRIGHT:
      shufflestring(&TrimString, SHUFFLERIGHT);
      if ((void *) TrimString > StrPtr) {
        TrimString--;
      }
      break;
    }
  }
}

void shufflestring(char **ShuffleStr, unsigned char Direction) {

  switch (Direction) {
  case SHUFFLELEFT:
    memmove((void *) *ShuffleStr, *ShuffleStr + 1, (size_t) strlen(*ShuffleStr));
    break;
  case SHUFFLERIGHT:
        **ShuffleStr = '\0';
    break;
  }
}

short FileExists(char *FileName) {
 return(exist(FileName));
}

void DeleteFiles(char *IFileName) {
char path[MAXPATH];
unsigned char MallocFlag = 0;
char DeleteFile[MAXPATH];
char FileExt[MAXEXT];
char FileName[MAXFILE];
char Drive[MAXDRIVE];
char Direct[MAXDIR];
struct ffblk find_buf;
int error;

  strcpy(path, IFileName);
  fnsplit(path, Drive, Direct, FileName, FileExt);
  error = findfirst(path, &find_buf, FA_NORMAL | FA_HIDDEN | FA_SYSTEM);
  while(!error) {
    strcpy(DeleteFile, Drive);
    strcat(DeleteFile, Direct);
    strcat(DeleteFile, find_buf.ff_name);
    if (!IsLocked(DeleteFile)) {
      unlink(DeleteFile);
    }
    error = findnext(&find_buf);
  }
  if (MallocFlag)
    free((void *)path);
  return;
}

/** MAKECLADATE ***************************************************************
 *
 *  Synopsis:
 *      static CLADATE MakeClaDate(DosDate);
 *
 *          unsigned    DosDate;        Date in DOS format
 *
 *  Description:
 *      MakeClaDate() takes a dos format date in DosDate and returns a
 *      Clarion format date.
 */

static CLADATE MakeClaDate(unsigned DosDate)
{   CLADATE ClaDate;
    union {
        unsigned    u;
        struct {
        unsigned    day     : 5;
        unsigned    month   : 4;
        unsigned    year    : 7;
        }           s;
    }   d;

    d.u = DosDate;

    ClaDate.l = 0l;
    ClaDate.s.usYear  = d.s.year + 1980;
    ClaDate.s.ucMonth = d.s.month;
    ClaDate.s.ucDay   = d.s.day;

    return ClaDate;
}

void _FileDate(char *IFileName, char *DateBuff) {
struct ffblk find_block;
CLADATE ClarionDate;
short error;

  error = findfirst(IFileName, &find_block, FA_NORMAL | FA_HIDDEN | FA_SYSTEM);
  if (! error) {
          ClarionDate = MakeClaDate(find_block.ff_fdate);
          sprintf(DateBuff, "%04d%02d%02d", ClarionDate.s.usYear,
                                             ClarionDate.s.ucDay,
                                             ClarionDate.s.ucMonth);
  } else {
    memset((void *) DateBuff, '0', 9);
  }
  return;
}

short IsLocked(char *FileName) {
int Hdl;
int Return = 0;
  Hdl = open(FileName, O_BINARY | O_WRONLY | O_EXCL, S_IWRITE);
  if (Hdl == -1) {
    switch(errno) {
    case EACCES:
      Return = 1;
      break;
    case EEXIST:
      break;
    case EMFILE:
      break;
    case ENOENT:
      break;
    }
  } else {
    close(Hdl);
  }
  return(Return);
}

void CursorOff(void) {
union REGS Regs;

  Regs.h.ch = 0x20;
  Regs.h.ah = 0x10;
  int86(0x10, &Regs, &Regs);
// cursoroff();
}
typedef struct Bytes {
        unsigned char l;
        unsigned char h;
} Bytes;

union f {
        short rx;
        struct Bytes h;
} f;

void EMMInfo(char *lFileName) {
char OutString[80];
static GlobalRecPtr GR;
char *EMMHostTitle[] = {
                        "Native",
                        "XMS",
                        "VCPI",
                        "VCPI/XMS",
                        "DPMI"
                       };
char *ProcessorTitle[] = {
                            "", "286", "386"
                          };
char *DriveNm = ".ABCDEFGHIJKLMNOPQRSTUVWXYZ";
union f j;


  GR = GETGLOBALPTR();
  j.rx = GR->dosver;
  if (!lFileName) {
    fprintf(stdout, "Processor Type %s (min)\n", ProcessorTitle[GR->processor_type]);
    fprintf(stdout, "EMM Host Type %s\n", EMMHostTitle[GR->host_kind]);
    fprintf(stdout, "DOS Version V%d.%d", j.h.h, j.h.l);
  } else {
    sprintf(OutString,"Processor Type %s (min)\n", ProcessorTitle[GR->processor_type]);
    StuffFile(lFileName, OutString);
    sprintf(OutString,"EMM Host Type %s\n", EMMHostTitle[GR->host_kind]);
    StuffFile(lFileName, OutString);
    sprintf(OutString, "DOS Version V%d.%d", j.h.h, j.h.l);
    StuffFile(lFileName, OutString);
    sprintf(OutString, "Virtual Drive %c:", DriveNm[GR->virtual_drive]);
    StuffFile(lFileName, OutString);
    sprintf(OutString, "Print Screen %s Active", GR->PrtScreenProc ? "Is" : "Is NOT");
    StuffFile(lFileName, OutString);
  }
}

void CClip(short Len, char *Str) {
  char *ptr;

  ptr = Str + Len;
  while (*ptr == ' ') {
    *ptr = '\0';
    ptr--;
  }
} /** End CClip() **/


void StuffFile(char *FileName, char *LogString) {
  FILE *fp;

  fp = fopen(FileName, "a");
  if (fp) {
    fprintf(fp, "%s\n", LogString);
    fclose(fp);
  }
}

